

class settings:
    __first_name = ""
    __tax_id = 0
    __bank_id = 0
    __bank_account_id = 0
    __corresp_account_id = 0
    __property_name = ""
    __property_type = ""
    
    @property
    def first_name(self):
        return self.__first_name
    
    @first_name.setter
    def first_name(self, value: str):
        """
            Полное наименование
        Args:
            value (str): Полное наименование

        Raises:
            TypeError: Некорректный аргумента
        """
        if not isinstance(value, str):
            raise TypeError("Некорректный аргумент!")
        
        self.__first_name = value.strip()

    @property
    def tax_id(self):
        return self.__tax_id
    
    @tax_id.setter
    def tax_id(self, value: int):
        """
            ИНН
        Args:
            value (int): Значение ИНН, 12 символов

        Raises:
            TypeError: Некорректный тип аргумента
            ValueError: Некорректная длина аргумента
        """

        if not isinstance(value, int):
            raise TypeError("Некорректный тип аргумента")
        
        if not len(str(value)) == 12:
            raise ValueError("Некорректная длина аргумента")

        self.__tax_id = value
    
    @property
    def bank_id(self):
        return self.__bank_id
    
    @bank_id.setter
    def bank_id(self, value: int):
        """
            БИК
        Args:
            value (int): Значение БИК, 9 символов

        Raises:
            TypeError: Некорректный тип аргумента
            ValueError: Некорректная длина аргумента
        """

        if not isinstance(value, int):
            raise TypeError("Некорректный тип аргумента")
        
        if not len(str(value)) == 9:
            raise ValueError("Некорректная длина аргумента")

        self.__bank_id = value

    
    @property
    def bank_account_id(self):
        return self.__bank_account_id
    
    @bank_account_id.setter
    def bank_account_id(self, value: int):
        """
            Номер банковского счета
        Args:
            value (int): Номер банковского счета, 11 символов

        Raises:
            TypeError: Некорректный тип аргумента
            ValueError: Некорректная длина аргумента
        """

        if not isinstance(value, int):
            raise TypeError("Некорректный тип аргумента")
        
        if not len(str(value)) == 11:
            raise ValueError("Некорректная длина аргумента")

        self.__bank_account_id = value
        

    @property
    def corresp_account_id(self):
        return self.__corresp_account_id
    
    @corresp_account_id.setter
    def corresp_account_id(self, value: int):
        """
            Номер корреспондентского счёта
        Args:
            value (int): Номер корреспондентского счёта, 11 символов

        Raises:
            TypeError: Некорректный тип аргумента
            ValueError: Некорректная длина аргумента
        """

        if not isinstance(value, int):
            raise TypeError("Некорректный тип аргумента")
        
        if not len(str(value)) == 11:
            raise ValueError("Некорректная длина аргумента")

        self.__corresp_account_id = value


    @property
    def property_name(self):
        return self.__property_name
    
    @property_name.setter
    def property_name(self, value: str):
        """
            Наименование собственности
        Args:
            value (str): Наименование собственности

        Raises:
            TypeError: Некорректный тип аргумента
        """

        if not isinstance(value, str):
            raise TypeError("Некорректный тип аргумента")
        

        self.__property_name = value

    
    @property
    def property_type(self):
        return self.__property_type
    
    @property_type.setter
    def property_type(self, value: str):
        """
            Тип собственности
        Args:
            value (str): Тип собственности, 5 символов

        Raises:
            TypeError: Некорректный тип аргумента
            ValueError: Некорректная длина аргумента
        """

        if not isinstance(value, str):
            raise TypeError("Некорректный тип аргумента")
        
        if not len(str(value)) == 5:
            raise ValueError("Некорректная длина аргумента")

        self.__property_type = value